/*
 *  TInput.h
 *
 *  Created by EdzUp on 25/07/2010.
 *  Copyright 2010 Graveyard Dogs. All rights reserved.
 *
 */

#if TARGET_OS_IPHONE || TARGET_OS_SIMULATOR
	//if we are using it on a iPod/iPhone then we can call the externs from EAGLView.mm to get touch positions
	extern double mouseXPosition;
	extern double mouseYPosition;
#else
	//otherwise we have to declare them here so not to cause errors.
	double	mouseXPosition;
	double	mouseYPosition;
#endif

class TInputClass {
public:
	//--------------------------------------------------------------------------------------------------------------
	double mouseX( void ) {
		return( mouseXPosition );
	}
	
	//--------------------------------------------------------------------------------------------------------------
	double mouseY( void ) {
		return( mouseYPosition );
	}

	//--------------------------------------------------------------------------------------------------------------
	void resetMousePosition( void ) {
		mouseXPosition = -1;
		mouseYPosition = -1;
	}
};

typedef TInputClass TInput;
