/*
 *  TombstoneFacebook.h
 *  Treasure Caves
 *
 *  Created by EdzUp on 27/09/2010.
 *  Copyright 2010 Graveyard Dogs. All rights reserved.
 *
 */

#if TARGET_OS_IPHONE || TARGET_OS_SIMULATOR
#import "FBConnect.h"

static NSString* kAppId = @"163791343632433";
//static NSString* kAppSecret = @"fd050d6ebed3f0db462b31e32c583177";

Facebook* _facebook;
NSArray* _permissions;

NSString* FacebookAppName;
NSString* FacebookAppWebsite;

void FacebookSetApplicationInformation( const NSString* name, const NSString* website ) {
	FacebookAppName = name;
	FacebookAppWebsite = website;
}

short FacebookConnect( void ) {
	//connect to facebook
	
	//setup permissions
	_permissions =  [[NSArray arrayWithObjects: 
					  @"publish_stream",@"read_stream", @"offline_access",nil] retain];
	
	//begin facebook connections
	_facebook = [[Facebook alloc] init];
	[_facebook authorize:kAppId permissions:_permissions delegate:nil];
	
	return( true );
}

void FacebookPostData( NSString* text, NSString* subtext ) {
	//Check to see if the user is letting us make the post
	//Set up the json encoded message as defined by Facebook SDK	
//	NSString* data = [NSString stringWithFormat:@"{\"name\":\"WOOHOO\",\"caption\":\"scored LOADS of points\"}"];
	SBJSON *jsonWriter = [[SBJSON new] autorelease];
	
	NSDictionary* actionLinks = [NSArray arrayWithObjects:[NSDictionary dictionaryWithObjectsAndKeys: 
														   FacebookAppName,@"text", FacebookAppWebsite,@"href", nil], nil];
	
	NSString *actionLinksStr = [jsonWriter stringWithObject:actionLinks];
	
//	NSString *caption = [NSString stringWithFormat:@"%@", text];
	NSDictionary* attachment = [NSDictionary dictionaryWithObjectsAndKeys:
								FacebookAppName, @"name",
								text, @"description",
								subtext, @"caption",
								FacebookAppWebsite, @"link", nil];
	NSString *attachmentStr = [jsonWriter stringWithObject:attachment];
	
	NSMutableDictionary* params = [NSMutableDictionary dictionaryWithObjectsAndKeys: //user_message_prompt
								   kAppId, @"api_key",							//its app id
								   @" ", @"message",							//required for publish clicking
								   actionLinksStr, @"action_links",
								   attachmentStr, @"attachment",
								   nil];

	[_facebook dialog: @"stream.publish"
			andParams: params
		  andDelegate: nil];
}

void FacebookPost( void ) {
	NSMutableDictionary* params = [NSMutableDictionary dictionaryWithObjectsAndKeys: kAppId, @"api_key", nil];
	
	[_facebook dialog: @"stream.publish" andParams: params andDelegate:nil];
}

void FacebookUserInformation( void ) {
	[_facebook requestWithGraphPath:@"me" andDelegate:nil];             // get information about the currently logged in user
}

void FacebookGamePosts( void ) {
	[_facebook requestWithGraphPath:@"platform/posts" andDelegate:nil]; // get the posts made by the "platform" page
}

void FacebookFriendsList( void ) {
	[_facebook requestWithGraphPath:@"me/friends" andDelegate:nil];     // get the logged-in user's friends
}

void FacebookLogout( void ) {
	[_facebook logout:nil];
}
	
#endif
