/*
 *  EdzUpStringSystem.h
 *  FreeFalling
 *
 *  Created by EdzUp on 24/02/2010.
 *  Copyright 2010 Graveyard Dogs. All rights reserved.
 *
 */

#include <stdlib.h>
#include <string.h>

#define BUFSIZE (sizeof(long) * 8 + 1)

char *ltoa(long N, char *str, int base)
{
	register int i = 2;
	long uarg;
	char *tail, *head = str, buf[BUFSIZE];
	
	if (36 < base || 2 > base)
		base = 10;                    /* can only use 0-9, A-Z        */
	tail = &buf[BUFSIZE - 1];           /* last character position      */
	*tail-- = '\0';
	
	if (10 == base && N < 0L)
	{
		*head++ = '-';
		uarg    = -N;
	}
	else  uarg = N;
	
	if (uarg)
	{
		for (i = 1; uarg; ++i)
		{
			register ldiv_t r;
			
			r       = ldiv(uarg, base);
			*tail-- = (char)(r.rem + ((9L < r.rem) ?
									  ('A' - 10L) : '0'));
			uarg    = r.quot;
		}
	}
	else  *tail-- = '0';
	
	memcpy(head, ++tail, i);
	return str;
}

char* Stri( int value ) {
	//convert an int to a string
	char *retstr;
	
	sprintf( retstr, "%i",value );
	
	return( retstr );
}
