/*
 *  Tombstone.h
 *
 *  Created by EdzUp on 17/03/2010.
 *  Copyright 2010 Graveyard Dogs. All rights reserved.
 *
 */

/*
 Software License Agreement for Tombstone Engine
 
 PLEASE READ CAREFULLY: BY INSTALLING THE SOFTWARE (AS DEFINED BELOW) AND/OR USING ANY PART OF THE SOFTWARE BELOW, YOU,
 (EITHER ON BEHALF OF YOURSELF AS AN INDIVIDUAL OR ON BEHALF OF AN ENTITY AS ITS AUTHORIZED REPRESENTATIVE) AGREE TO ALL
 OF THE TERMS OF THIS END USER LICENSE AGREEMENT REGARDING THE USE OF THE SOFTWARE. IF YOU DO NOT AGREE WITH ALL OF THE
 TERMS OF THIS AGREEMENT, CLICK ON THE 'DISAGREE' BUTTON. THIS WILL CANCEL THE INSTALLATION.
 
 1) The license is granted so you can use Tombstone engine in your own games and applications, the license non-exclusive
	and may not be transfered to anyone else without written permission from Graveyard Dogs or any of its employees.
 
 2) Any game or application using Tombstone engine must display a full screen logo in the startup sequence, the logos and
	text 'created with Tombstone Engine' must be displayed prominently through out the game or application.
 
 3) Modifying the source code to Tombstone Engine is 'encouraged' and any adjustments to the engine must be submitted to
	graveyard dogs for 'approval', and the adjustments themselves will become Graveyard Dogs interllectual property if
	they are ratified.
 
 4) Licensee's may only store the source on two computers or virtual machines, you may store it for backup purposes and may
	retain one copy for reinstallation.
 
 5) By using Tombstone Engine you agree that any damage sustained from using this engine or any of its source code is the
	users entirely and no legal discourse will be entered into between yourselves and Graveyard Dogs. We do acknowledge that
	in some states or countries this disclaimer may not affect you. Graveyard dogs do not guarantee that the Tombstone
	Engine will perform as specified in any literature or electronic media.
*/

//this has ALL the file for the Tombstone engine in it for easy insertion
#import "TombstoneCompatibility.h"
#import "TombstoneVariables.h"
#import "TRegistry.h"
#import "TEntity.h"
#import "TSprite.h"
#import "TTexture.h"
#import "TSound.h"
#import "TNetwork.h"
#import "TInput.h"
#import "TText.h"
#import "TombstoneEngine.h"				//this is the main engine
#import "TombstoneRandomSystem.h"		//this is the random generator system for Tombstone
#import "TombstoneFileSystem.h"			//All the file system functions
#import "TombstoneFPS.h"
#if defined( __APPLE__ )
#if TARGET_OS_IPHONE || TARGET_OS_SIMULATOR
	#import "TombstoneiPhoneFunctions.h"	//All iPhone functions for setting up everything on iPhone
#endif
#endif
#if defined( __WINDOWS__ )
	#import "TombstoneWindowsFunctions.h"	//All windows functions and settings for everything Windows related
#endif

TombstoneClass Tombstone;
