/*
 *  TombstoneFPS.h
 *  Treasure Caves
 *
 *  Created by EdzUp on 15/11/2010.
 *  Copyright 2010 Graveyard Dogs. All rights reserved.
 *
 */

#include <stdio.h>
#include <time.h>

class TombstoneFPSClass {
public:
	string	oldTime;
	long	lastFPS;
	long	FPSCounter;

	string currentTime( void ) {
		// localtime example
	
		time_t rawtime;
		struct tm * timeinfo;
		
		time ( &rawtime );
		timeinfo = localtime ( &rawtime );
		
		return( asctime( timeinfo ) );
	}
	
	//======================================================================================================
	long updateFPS( void ) {
		//this will update the FPS system
		string check = currentTime();
		
		FPSCounter++;
		if ( check != oldTime ) {
			lastFPS = FPSCounter;
			FPSCounter = 0;
			oldTime = check;
			
			cout << "FPS:" << lastFPS << endl;
		}
		
		return( lastFPS );
	}
};

typedef TombstoneFPSClass TFPS;

TFPS TombstoneFPS;
